﻿using ICP.Reporting.ReportingClassLibrary;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Controls.Reports;

namespace ICP.Reporting.WPFReportViewer.Windows
{
    /// <summary>
    /// Interaction logic for Report_Script_Resultaten.xaml
    /// </summary>
    public partial class Report_Script_Resultaten : Window
    {
        public Report_Script_Resultaten()
        {
            InitializeComponent();

            CultureInfo ci = CultureInfo.CreateSpecificCulture(CultureInfo.CurrentCulture.Name);
            ci.DateTimeFormat.ShortDatePattern = "dd/MM/yyyy";
            ci.DateTimeFormat.DateSeparator = "-";
            Thread.CurrentThread.CurrentCulture = ci;

            //datePickerBeginDatum.DisplayDate = DateTime.Today.AddDays(-7);
            //datePickerBeginDatum.SelectedDate = DateTime.Today.AddDays(-7);
            //datePickerEindDatum.DisplayDate = DateTime.Today.AddDays(-1);            
            //datePickerEindDatum.SelectedDate = DateTime.Today.AddDays(-1);

            BindComboBoxAuthoriteit(comboBoxAuthoriteit);
        }
                     
        public void BindComboBoxAuthoriteit(ComboBox comboBoxName)
        {            
            DataSet dsAuthoriteit = OpenConnectionAuthoriteit();
            comboBoxName.ItemsSource = dsAuthoriteit.Tables[0].DefaultView;
            comboBoxAuthoriteit.SelectionChanged -= new SelectionChangedEventHandler(comboBoxAuthoriteit_SelectionChanged);
            comboBoxName.DisplayMemberPath = dsAuthoriteit.Tables[0].Columns["Description"].ToString();
            comboBoxName.SelectedValuePath = dsAuthoriteit.Tables[0].Columns["Authority_ID"].ToString();
            comboBoxAuthoriteit.SelectionChanged += new SelectionChangedEventHandler(comboBoxAuthoriteit_SelectionChanged);
        }

        private static DataSet OpenConnectionAuthoriteit()
        {
            string strConnectionAuthoriteit = ConfigurationManager.ConnectionStrings["ICP.Reporting.ReportingClassLibrary.Properties.Settings.sqlDS_Authorities"].ConnectionString;
            SqlConnection connectionAuthoriteit = new SqlConnection(strConnectionAuthoriteit);
            SqlDataAdapter daAuthoriteit = new SqlDataAdapter("SELECT Authority_ID, Description FROM Authorities ORDER BY Description", connectionAuthoriteit);
            DataSet dsAuthoriteit = new DataSet();
            daAuthoriteit.Fill(dsAuthoriteit, "Authorities");
            return dsAuthoriteit;
        }

        private void comboBoxAuthoriteit_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {            
            if (comboBoxAuthoriteit.SelectedIndex > -1)
            {
                BindComboBoxScript(comboBoxScript);
            }
        }

        public void BindComboBoxScript(ComboBox comboBoxName)
        {
            string strqryScript = string.Format("SELECT Questionnaire_Id, Questionnaire_Name FROM Questionnaires WHERE (Authority_ID = {0}) ORDER BY Questionnaire_Name", comboBoxAuthoriteit.SelectedValue);

            string strConnectionScript = ConfigurationManager.ConnectionStrings["ICP.Reporting.ReportingClassLibrary.Properties.Settings.sqlDS_Scripts"].ConnectionString;
            SqlConnection connectionScript = new SqlConnection(strConnectionScript);
            SqlDataAdapter daScript = new SqlDataAdapter(strqryScript, connectionScript);
            DataSet dsScript = new DataSet();
            //DataTable dtScript = new DataTable();
            daScript.Fill(dsScript, "Questionnaires");

            comboBoxName.ItemsSource = dsScript.Tables[0].DefaultView;
            comboBoxName.DisplayMemberPath = dsScript.Tables[0].Columns["Questionnaire_Name"].ToString();
            comboBoxName.SelectedValuePath = dsScript.Tables[0].Columns["Questionnaire_Id"].ToString();

            //string strqryScript = string.Format("SELECT Questionnaire_Id, Questionnaire_Name FROM Questionnaires WHERE Authority_ID = @AuthorityID ORDER BY Questionnaire_Name");

            //string strConnectionScript = ConfigurationManager.ConnectionStrings["ICP.Reporting.ReportingClassLibrary.Properties.Settings.sqlDS_Scripts"].ConnectionString;

            //DataTable dtScript = new DataTable();
            //SqlConnection connectionScript = new SqlConnection(strConnectionScript);
            //SqlCommand cmdScript = new SqlCommand(strqryScript, connectionScript);
            ////cmdScript.Parameters.Add(new SqlParameter("@AuthorityID", System.Data.SqlDbType.Int).Value = comboBoxAuthoriteit.SelectedValue);
            //cmdScript.Parameters.Add(new SqlParameter("@AuthorityID", SqlDbType.Int).Value = comboBoxAuthoriteit.SelectedValue);
            //connectionScript.Open();
            //SqlDataReader drScript = cmdScript.ExecuteReader();
            //dtScript.Load(drScript);

            //comboBoxScript.ItemsSource = dtScript.DefaultView;
            //comboBoxScript.DisplayMemberPath = "Questionnaire_Name";
            //comboBoxScript.SelectedValuePath = "Questionnaire_Id";

            //connectionScript.Close();            
        }

        private void Button_Refresh_Click(object sender, RoutedEventArgs e)
        {
            this.xamReportViewer1.Refresh();
        }
    }    
}
